---
title: Update security signal triage state or assignee
description: Datadog, the leading service for cloud-scale monitoring.
breadcrumbs: Docs > API Reference > Security Monitoring
---

# Update security signal triage state or assignee{% #update-security-signal-triage-state-or-assignee %}
Copy pageCopied
{% tab title="v2" %}

| Datadog site      | API endpoint                                                                              |
| ----------------- | ----------------------------------------------------------------------------------------- |
| ap1.datadoghq.com | PATCH https://api.ap1.datadoghq.com/api/v2/security_monitoring/signals/{signal_id}/update |
| ap2.datadoghq.com | PATCH https://api.ap2.datadoghq.com/api/v2/security_monitoring/signals/{signal_id}/update |
| app.datadoghq.eu  | PATCH https://api.datadoghq.eu/api/v2/security_monitoring/signals/{signal_id}/update      |
| app.ddog-gov.com  | PATCH https://api.ddog-gov.com/api/v2/security_monitoring/signals/{signal_id}/update      |
| us2.ddog-gov.com  | PATCH https://api.us2.ddog-gov.com/api/v2/security_monitoring/signals/{signal_id}/update  |
| app.datadoghq.com | PATCH https://api.datadoghq.com/api/v2/security_monitoring/signals/{signal_id}/update     |
| us3.datadoghq.com | PATCH https://api.us3.datadoghq.com/api/v2/security_monitoring/signals/{signal_id}/update |
| us5.datadoghq.com | PATCH https://api.us5.datadoghq.com/api/v2/security_monitoring/signals/{signal_id}/update |

### Overview

Update the triage state or assignee of a security signal. This endpoint requires the `security_monitoring_signals_write` permission.

### Arguments

#### Path Parameters

| Name                        | Type   | Description           |
| --------------------------- | ------ | --------------------- |
| signal_id [*required*] | string | The ID of the signal. |

### Request

#### Body Data (required)

Attributes describing the signal triage state or assignee update.

{% tab title="Model" %}

| Parent field | Field                        | Type   | Description                                                                                                                                                                           |
| ------------ | ---------------------------- | ------ | ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
|              | data [*required*]       | object | Data containing the triage state or assignee update for a security signal.                                                                                                            |
| data         | attributes [*required*] | object | Attributes for updating the triage state or assignee of a security signal.                                                                                                            |
| attributes   | archive_comment              | string | Optional comment to display on archived signals.                                                                                                                                      |
| attributes   | archive_reason               | enum   | Reason a signal is archived. Allowed enum values: `none,false_positive,testing_or_maintenance,remediated,investigated_case_opened,true_positive_benign,true_positive_malicious,other` |
| attributes   | assignee                     | object | Object representing a given user entity.                                                                                                                                              |
| assignee     | handle                       | string | The handle for this user account.                                                                                                                                                     |
| assignee     | icon                         | string | Gravatar icon associated to the user.                                                                                                                                                 |
| assignee     | id                           | int64  | Numerical ID assigned by Datadog to this user account.                                                                                                                                |
| assignee     | name                         | string | The name for this user account.                                                                                                                                                       |
| assignee     | uuid [*required*]       | string | UUID assigned by Datadog to this user account.                                                                                                                                        |
| attributes   | state                        | enum   | The new triage state of the signal. Allowed enum values: `open,archived,under_review`                                                                                                 |
| attributes   | version                      | int64  | Version of the updated signal. If server side version is higher, update will be rejected.                                                                                             |
| data         | type                         | enum   | The type of event. Allowed enum values: `signal_metadata`                                                                                                                             |

{% /tab %}

{% tab title="Example" %}

```json
{
  "data": {
    "attributes": {
      "archive_comment": "string",
      "archive_reason": "string",
      "assignee": {
        "handle": "string",
        "id": "integer",
        "name": "string",
        "uuid": "773b045d-ccf8-4808-bd3b-955ef6a8c940"
      },
      "state": "open",
      "version": "integer"
    },
    "type": "signal_metadata"
  }
}
```

{% /tab %}

### Response

{% tab title="200" %}
OK
{% tab title="Model" %}
The response returned after all triage operations, containing the updated signal triage data.

| Parent field         | Field                          | Type      | Description                                                                                                                                                                           |
| -------------------- | ------------------------------ | --------- | ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
|                      | data [*required*]         | object    | Data containing the updated triage attributes of the signal.                                                                                                                          |
| data                 | attributes                     | object    | Attributes describing a triage state update operation over a security signal.                                                                                                         |
| attributes           | archive_comment                | string    | Optional comment to display on archived signals.                                                                                                                                      |
| attributes           | archive_comment_timestamp      | int64     | Timestamp of the last edit to the comment.                                                                                                                                            |
| attributes           | archive_comment_user           | object    | Object representing a given user entity.                                                                                                                                              |
| archive_comment_user | handle                         | string    | The handle for this user account.                                                                                                                                                     |
| archive_comment_user | icon                           | string    | Gravatar icon associated to the user.                                                                                                                                                 |
| archive_comment_user | id                             | int64     | Numerical ID assigned by Datadog to this user account.                                                                                                                                |
| archive_comment_user | name                           | string    | The name for this user account.                                                                                                                                                       |
| archive_comment_user | uuid [*required*]         | string    | UUID assigned by Datadog to this user account.                                                                                                                                        |
| attributes           | archive_reason                 | enum      | Reason a signal is archived. Allowed enum values: `none,false_positive,testing_or_maintenance,remediated,investigated_case_opened,true_positive_benign,true_positive_malicious,other` |
| attributes           | assignee [*required*]     | object    | Object representing a given user entity.                                                                                                                                              |
| assignee             | handle                         | string    | The handle for this user account.                                                                                                                                                     |
| assignee             | icon                           | string    | Gravatar icon associated to the user.                                                                                                                                                 |
| assignee             | id                             | int64     | Numerical ID assigned by Datadog to this user account.                                                                                                                                |
| assignee             | name                           | string    | The name for this user account.                                                                                                                                                       |
| assignee             | uuid [*required*]         | string    | UUID assigned by Datadog to this user account.                                                                                                                                        |
| attributes           | incident_ids [*required*] | [integer] | Array of incidents that are associated with this signal.                                                                                                                              |
| attributes           | state [*required*]        | enum      | The new triage state of the signal. Allowed enum values: `open,archived,under_review`                                                                                                 |
| attributes           | state_update_timestamp         | int64     | Timestamp of the last update to the signal state.                                                                                                                                     |
| attributes           | state_update_user              | object    | Object representing a given user entity.                                                                                                                                              |
| state_update_user    | handle                         | string    | The handle for this user account.                                                                                                                                                     |
| state_update_user    | icon                           | string    | Gravatar icon associated to the user.                                                                                                                                                 |
| state_update_user    | id                             | int64     | Numerical ID assigned by Datadog to this user account.                                                                                                                                |
| state_update_user    | name                           | string    | The name for this user account.                                                                                                                                                       |
| state_update_user    | uuid [*required*]         | string    | UUID assigned by Datadog to this user account.                                                                                                                                        |
| data                 | id                             | string    | The unique ID of the security signal.                                                                                                                                                 |
| data                 | type                           | enum      | The type of event. Allowed enum values: `signal_metadata`                                                                                                                             |

{% /tab %}

{% tab title="Example" %}

```json
{
  "data": {
    "attributes": {
      "archive_comment": "string",
      "archive_comment_timestamp": "integer",
      "archive_comment_user": {
        "handle": "string",
        "icon": "/path/to/matching/gravatar/icon",
        "id": "integer",
        "name": "string",
        "uuid": "773b045d-ccf8-4808-bd3b-955ef6a8c940"
      },
      "archive_reason": "string",
      "assignee": {
        "handle": "string",
        "icon": "/path/to/matching/gravatar/icon",
        "id": "integer",
        "name": "string",
        "uuid": "773b045d-ccf8-4808-bd3b-955ef6a8c940"
      },
      "incident_ids": [
        2066
      ],
      "state": "open",
      "state_update_timestamp": "integer",
      "state_update_user": {
        "handle": "string",
        "icon": "/path/to/matching/gravatar/icon",
        "id": "integer",
        "name": "string",
        "uuid": "773b045d-ccf8-4808-bd3b-955ef6a8c940"
      }
    },
    "id": "string",
    "type": "signal_metadata"
  }
}
```

{% /tab %}

{% /tab %}

{% tab title="400" %}
Bad Request
{% tab title="Model" %}
API error response.

| Parent field | Field                    | Type     | Description                                                                     |
| ------------ | ------------------------ | -------- | ------------------------------------------------------------------------------- |
|              | errors [*required*] | [object] | A list of errors.                                                               |
| errors       | detail                   | string   | A human-readable explanation specific to this occurrence of the error.          |
| errors       | meta                     | object   | Non-standard meta-information about the error                                   |
| errors       | source                   | object   | References to the source of the error.                                          |
| source       | header                   | string   | A string indicating the name of a single request header which caused the error. |
| source       | parameter                | string   | A string indicating which URI query parameter caused the error.                 |
| source       | pointer                  | string   | A JSON pointer to the value in the request document that caused the error.      |
| errors       | status                   | string   | Status code of the response.                                                    |
| errors       | title                    | string   | Short human-readable summary of the error.                                      |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="403" %}
Forbidden
{% tab title="Model" %}
API error response.

| Parent field | Field                    | Type     | Description                                                                     |
| ------------ | ------------------------ | -------- | ------------------------------------------------------------------------------- |
|              | errors [*required*] | [object] | A list of errors.                                                               |
| errors       | detail                   | string   | A human-readable explanation specific to this occurrence of the error.          |
| errors       | meta                     | object   | Non-standard meta-information about the error                                   |
| errors       | source                   | object   | References to the source of the error.                                          |
| source       | header                   | string   | A string indicating the name of a single request header which caused the error. |
| source       | parameter                | string   | A string indicating which URI query parameter caused the error.                 |
| source       | pointer                  | string   | A JSON pointer to the value in the request document that caused the error.      |
| errors       | status                   | string   | Status code of the response.                                                    |
| errors       | title                    | string   | Short human-readable summary of the error.                                      |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="404" %}
Not Found
{% tab title="Model" %}
API error response.

| Parent field | Field                    | Type     | Description                                                                     |
| ------------ | ------------------------ | -------- | ------------------------------------------------------------------------------- |
|              | errors [*required*] | [object] | A list of errors.                                                               |
| errors       | detail                   | string   | A human-readable explanation specific to this occurrence of the error.          |
| errors       | meta                     | object   | Non-standard meta-information about the error                                   |
| errors       | source                   | object   | References to the source of the error.                                          |
| source       | header                   | string   | A string indicating the name of a single request header which caused the error. |
| source       | parameter                | string   | A string indicating which URI query parameter caused the error.                 |
| source       | pointer                  | string   | A JSON pointer to the value in the request document that caused the error.      |
| errors       | status                   | string   | Status code of the response.                                                    |
| errors       | title                    | string   | Short human-readable summary of the error.                                      |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="429" %}
Too many requests
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

### Code Example

##### 
                  \## default
# 
 \# Path parameters export signal_id="CHANGE_ME" \# Curl command curl -X PATCH "https://api.datadoghq.com/api/v2/security_monitoring/signals/${signal_id}/update" \
-H "Accept: application/json" \
-H "Content-Type: application/json" \
-H "DD-API-KEY: ${DD_API_KEY}" \
-H "DD-APPLICATION-KEY: ${DD_APP_KEY}" \
-d @- << EOF
{
  "data": {
    "attributes": {
      "archive_reason": "none",
      "state": "archived"
    },
    "type": "signal_metadata"
  }
}
EOF 
                
##### 

```python
"""
Update security signal triage state or assignee returns "OK" response
"""

from datadog_api_client import ApiClient, Configuration
from datadog_api_client.v2.api.security_monitoring_api import SecurityMonitoringApi
from datadog_api_client.v2.model.security_monitoring_signal_archive_reason import SecurityMonitoringSignalArchiveReason
from datadog_api_client.v2.model.security_monitoring_signal_metadata_type import SecurityMonitoringSignalMetadataType
from datadog_api_client.v2.model.security_monitoring_signal_state import SecurityMonitoringSignalState
from datadog_api_client.v2.model.security_monitoring_signal_update_attributes import (
    SecurityMonitoringSignalUpdateAttributes,
)
from datadog_api_client.v2.model.security_monitoring_signal_update_data import SecurityMonitoringSignalUpdateData
from datadog_api_client.v2.model.security_monitoring_signal_update_request import SecurityMonitoringSignalUpdateRequest
from datadog_api_client.v2.model.security_monitoring_triage_user import SecurityMonitoringTriageUser

body = SecurityMonitoringSignalUpdateRequest(
    data=SecurityMonitoringSignalUpdateData(
        attributes=SecurityMonitoringSignalUpdateAttributes(
            archive_reason=SecurityMonitoringSignalArchiveReason.NONE,
            assignee=SecurityMonitoringTriageUser(
                uuid="773b045d-ccf8-4808-bd3b-955ef6a8c940",
            ),
            state=SecurityMonitoringSignalState.OPEN,
        ),
        type=SecurityMonitoringSignalMetadataType.SIGNAL_METADATA,
    ),
)

configuration = Configuration()
with ApiClient(configuration) as api_client:
    api_instance = SecurityMonitoringApi(api_client)
    response = api_instance.edit_security_monitoring_signal(signal_id="signal_id", body=body)

    print(response)
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=python) and then save the example to `example.py` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" python3 "example.py"
##### 

```ruby
# Update security signal triage state or assignee returns "OK" response

require "datadog_api_client"
api_instance = DatadogAPIClient::V2::SecurityMonitoringAPI.new

body = DatadogAPIClient::V2::SecurityMonitoringSignalUpdateRequest.new({
  data: DatadogAPIClient::V2::SecurityMonitoringSignalUpdateData.new({
    attributes: DatadogAPIClient::V2::SecurityMonitoringSignalUpdateAttributes.new({
      archive_reason: DatadogAPIClient::V2::SecurityMonitoringSignalArchiveReason::NONE,
      assignee: DatadogAPIClient::V2::SecurityMonitoringTriageUser.new({
        uuid: "773b045d-ccf8-4808-bd3b-955ef6a8c940",
      }),
      state: DatadogAPIClient::V2::SecurityMonitoringSignalState::OPEN,
    }),
    type: DatadogAPIClient::V2::SecurityMonitoringSignalMetadataType::SIGNAL_METADATA,
  }),
})
p api_instance.edit_security_monitoring_signal("signal_id", body)
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=ruby) and then save the example to `example.rb` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" rb "example.rb"
##### 

```go
// Update security signal triage state or assignee returns "OK" response

package main

import (
	"context"
	"encoding/json"
	"fmt"
	"os"

	"github.com/DataDog/datadog-api-client-go/v2/api/datadog"
	"github.com/DataDog/datadog-api-client-go/v2/api/datadogV2"
)

func main() {
	body := datadogV2.SecurityMonitoringSignalUpdateRequest{
		Data: datadogV2.SecurityMonitoringSignalUpdateData{
			Attributes: datadogV2.SecurityMonitoringSignalUpdateAttributes{
				ArchiveReason: datadogV2.SECURITYMONITORINGSIGNALARCHIVEREASON_NONE.Ptr(),
				Assignee: &datadogV2.SecurityMonitoringTriageUser{
					Uuid: "773b045d-ccf8-4808-bd3b-955ef6a8c940",
				},
				State: datadogV2.SECURITYMONITORINGSIGNALSTATE_OPEN.Ptr(),
			},
			Type: datadogV2.SECURITYMONITORINGSIGNALMETADATATYPE_SIGNAL_METADATA.Ptr(),
		},
	}
	ctx := datadog.NewDefaultContext(context.Background())
	configuration := datadog.NewConfiguration()
	apiClient := datadog.NewAPIClient(configuration)
	api := datadogV2.NewSecurityMonitoringApi(apiClient)
	resp, r, err := api.EditSecurityMonitoringSignal(ctx, "signal_id", body)

	if err != nil {
		fmt.Fprintf(os.Stderr, "Error when calling `SecurityMonitoringApi.EditSecurityMonitoringSignal`: %v\n", err)
		fmt.Fprintf(os.Stderr, "Full HTTP response: %v\n", r)
	}

	responseContent, _ := json.MarshalIndent(resp, "", "  ")
	fmt.Fprintf(os.Stdout, "Response from `SecurityMonitoringApi.EditSecurityMonitoringSignal`:\n%s\n", responseContent)
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=go) and then save the example to `main.go` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" go run "main.go"
##### 

```java
// Update security signal triage state or assignee returns "OK" response

import com.datadog.api.client.ApiClient;
import com.datadog.api.client.ApiException;
import com.datadog.api.client.v2.api.SecurityMonitoringApi;
import com.datadog.api.client.v2.model.SecurityMonitoringSignalArchiveReason;
import com.datadog.api.client.v2.model.SecurityMonitoringSignalMetadataType;
import com.datadog.api.client.v2.model.SecurityMonitoringSignalState;
import com.datadog.api.client.v2.model.SecurityMonitoringSignalTriageUpdateResponse;
import com.datadog.api.client.v2.model.SecurityMonitoringSignalUpdateAttributes;
import com.datadog.api.client.v2.model.SecurityMonitoringSignalUpdateData;
import com.datadog.api.client.v2.model.SecurityMonitoringSignalUpdateRequest;
import com.datadog.api.client.v2.model.SecurityMonitoringTriageUser;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = ApiClient.getDefaultApiClient();
    SecurityMonitoringApi apiInstance = new SecurityMonitoringApi(defaultClient);

    SecurityMonitoringSignalUpdateRequest body =
        new SecurityMonitoringSignalUpdateRequest()
            .data(
                new SecurityMonitoringSignalUpdateData()
                    .attributes(
                        new SecurityMonitoringSignalUpdateAttributes()
                            .archiveReason(SecurityMonitoringSignalArchiveReason.NONE)
                            .assignee(
                                new SecurityMonitoringTriageUser()
                                    .uuid("773b045d-ccf8-4808-bd3b-955ef6a8c940"))
                            .state(SecurityMonitoringSignalState.OPEN))
                    .type(SecurityMonitoringSignalMetadataType.SIGNAL_METADATA));

    try {
      SecurityMonitoringSignalTriageUpdateResponse result =
          apiInstance.editSecurityMonitoringSignal("signal_id", body);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println(
          "Exception when calling SecurityMonitoringApi#editSecurityMonitoringSignal");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=java) and then save the example to `Example.java` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" java "Example.java"
##### 

```rust
// Update security signal triage state or assignee returns "OK" response
use datadog_api_client::datadog;
use datadog_api_client::datadogV2::api_security_monitoring::SecurityMonitoringAPI;
use datadog_api_client::datadogV2::model::SecurityMonitoringSignalArchiveReason;
use datadog_api_client::datadogV2::model::SecurityMonitoringSignalMetadataType;
use datadog_api_client::datadogV2::model::SecurityMonitoringSignalState;
use datadog_api_client::datadogV2::model::SecurityMonitoringSignalUpdateAttributes;
use datadog_api_client::datadogV2::model::SecurityMonitoringSignalUpdateData;
use datadog_api_client::datadogV2::model::SecurityMonitoringSignalUpdateRequest;
use datadog_api_client::datadogV2::model::SecurityMonitoringTriageUser;

#[tokio::main]
async fn main() {
    let body = SecurityMonitoringSignalUpdateRequest::new(
        SecurityMonitoringSignalUpdateData::new(
            SecurityMonitoringSignalUpdateAttributes::new()
                .archive_reason(SecurityMonitoringSignalArchiveReason::NONE)
                .assignee(SecurityMonitoringTriageUser::new(
                    "773b045d-ccf8-4808-bd3b-955ef6a8c940".to_string(),
                ))
                .state(SecurityMonitoringSignalState::OPEN),
        )
        .type_(SecurityMonitoringSignalMetadataType::SIGNAL_METADATA),
    );
    let configuration = datadog::Configuration::new();
    let api = SecurityMonitoringAPI::with_config(configuration);
    let resp = api
        .edit_security_monitoring_signal("signal_id".to_string(), body)
        .await;
    if let Ok(value) = resp {
        println!("{:#?}", value);
    } else {
        println!("{:#?}", resp.unwrap_err());
    }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=rust) and then save the example to `src/main.rs` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" cargo run
##### 

```typescript
/**
 * Update security signal triage state or assignee returns "OK" response
 */

import { client, v2 } from "@datadog/datadog-api-client";

const configuration = client.createConfiguration();
const apiInstance = new v2.SecurityMonitoringApi(configuration);

const params: v2.SecurityMonitoringApiEditSecurityMonitoringSignalRequest = {
  body: {
    data: {
      attributes: {
        archiveReason: "none",
        assignee: {
          uuid: "773b045d-ccf8-4808-bd3b-955ef6a8c940",
        },
        state: "open",
      },
      type: "signal_metadata",
    },
  },
  signalId: "signal_id",
};

apiInstance
  .editSecurityMonitoringSignal(params)
  .then((data: v2.SecurityMonitoringSignalTriageUpdateResponse) => {
    console.log(
      "API called successfully. Returned data: " + JSON.stringify(data)
    );
  })
  .catch((error: any) => console.error(error));
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=typescript) and then save the example to `example.ts` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" tsc "example.ts"
{% /tab %}
